local drawableSprite = require("structs.drawable_sprite")
local utils = require("utils")

local CardinalBumper = {}

local versionCheck = require("mods").requireFromPlugin("libraries.MoreLoennPlugins.versionCheck")
if not versionCheck.validModVersion("JackalHelper", "1.6.8")
  then return {}
end
CardinalBumper.associatedMods = { "JackalHelper" }

CardinalBumper.name = "JackalHelper/CardinalBumper"
CardinalBumper.depth = 0
CardinalBumper.placements = {
    name = "default",
    data = {
        alwaysBumperBoost = false,
        wobble = false,
        spriteDirectory = "bumperCardinal",
        overRideString = ""
    }
}

function CardinalBumper.sprite(room, entity)
    return drawableSprite.fromTexture("objects/" .. entity.spriteDirectory .. "/Idle00", entity)
end

CardinalBumper.nodeLimits = {0, -1}

return CardinalBumper